#ifndef _CPLRAW_FLAGS_HXX
#define _CPLRAW_FLAGS_HXX 1

/*
 * flags.hxx
 * flags base class
 */

class Flags {
	int _f;			/* current state	*/
public:
	int clear(int f) { int __f=_f; _f = f; return __f; }
	int f() const { return _f; }
	//int setf(int f) { int __f=_f; _f |= f; return __f; }
	//int unsetf(int f) { int __f=_f; _f &= ~f; return __f; }

	int setFlag(int f) { int __f=_f; _f |= f; return __f; }
	int unsetFlag(int f) { int __f=_f; _f &= ~f; return __f; }
	int eatFlag(int f) { int __f=(_f&f); _f &= ~f; return __f; }
	bool setFlag(int f, bool fOn) 
	  { if (fOn) setFlag(f); else unsetFlag(f); return fOn; }

	bool isSet(int f) const { return (_f & f) != 0; }
	bool isClear(int f) const { return (_f & f) == 0; }
	bool isMask(int f, int fMask) const { return (_f & fMask)==f; }

	Flags(int f=0):_f(f) {}
	~Flags() {}
};

#endif 
