
#ifndef  _CPLRAW_SYNCH_HXX_
#define _CPLRAW_SYNCH_HXX_ 1


namespace INdepSynch100 {
    class Mutex {	/* implementation dependent */
      public:
	virtual void lock();
	virtual void unlock();
	Mutex();
	virtual ~Mutex();
    };

    class Guard {
	Mutex *_pmu;
      public:
	Guard(Mutex *pmu): _pmu(pmu) {
	    if (_pmu) _pmu->lock(); 
	}
	~Guard() { 
	    if (_pmu) _pmu->unlock(); 
	}
    };
}


#endif
